from typing import Optional

from cpl_translation import TranslatePipe
from discord.ext import commands
from discord.ext.commands import Context

from bot_core.abc.client_utils_service_abc import ClientUtilsServiceABC
from bot_core.abc.message_service_abc import MessageServiceABC
from bot_core.exception.check_error import CheckError
from modules.permission.abc.permission_service_abc import PermissionServiceABC


class EventChecks:
    _client_utils: Optional[ClientUtilsServiceABC] = None

    @classmethod
    def init(
            cls,
            client_utils: ClientUtilsServiceABC,
    ):
        cls._client_utils = client_utils

    @classmethod
    def check_is_ready(cls):
        async def check_if_bot_is_ready() -> bool:
            result = await cls._client_utils.check_if_bot_is_ready()
            if not result:
                raise CheckError(f'Bot is not ready')
            return result

        return commands.check(check_if_bot_is_ready)
